#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Dec  7 23:08:50 2020

@author: anton
"""

from SLiCAP import *

#prj = initProject('Dual stage')

# Dual stage with inverting current amp #######################################

fileName = 'DualStage'
#makeNetlist(fileName + '.asc', fileName)
i1 = instruction()
i1.setCircuit(fileName + '.cir')
htmlPage('Circuit data')
head2html('Circuit diagram')
img2html(fileName + '.svg', 800)
netlist2html(fileName + '.cir')

i1.defPar('L_A', 0.5)
i1.defPar('C_A', '5p')
i1.defPar('C_f', '2.5p')
elementData2html(i1.circuit)
params2html(i1.circuit)

i1.setSimType('numeric')
i1.setSource('V1')
i1.setDetector('V_out')
i1.setLGref('F1')

htmlPage('PZ analysis')

i1.setGainType('gain')
i1.setDataType('pz')
pz2html(i1.execute())
i1.setDataType('laplace')
gain = i1.execute()

i1.setGainType('loopgain')
i1.setDataType('pz')
pz2html(i1.execute())
i1.setDataType('laplace')
loopgain = i1.execute()

i1.setGainType('asymptotic')
i1.setDataType('pz')
pz2html(i1.execute())
i1.setDataType('laplace')
asymptotic = i1.execute()

i1.setGainType('servo')
i1.setDataType('pz')
pz2html(i1.execute())
i1.setDataType('laplace')
servo = i1.execute()

i1.setGainType('direct')
i1.setDataType('pz')
pz2html(i1.execute())
i1.setDataType('laplace')
direct = i1.execute()

htmlPage('Bode plots')
result = [asymptotic, gain, loopgain, servo, direct]
figdBmag = plotSweep(fileName + 'dBmag', 'dB magnitude', result, 1e8, 10e9, 100, funcType = 'dBmag', show=True)
figPhase = plotSweep(fileName + 'phase', 'Phase', result, 1e8, 10e9, 100, funcType = 'phase', show=True)
fig2html(figdBmag, 800)
fig2html(figPhase, 800)