#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Dec  7 23:08:50 2020

@author: anton
"""

from SLiCAP import *

prj = initProject('Dual stage mirror with resistors')

# Dual stage mirror with resistors ############################################

fileName = 'DualStageMirrorResComp1BondWires'
#makeNetlist(fileName + '.asc', fileName)
i1 = instruction()
i1.setCircuit(fileName + '.cir')
htmlPage('Circuit data')
head2html('Circuit diagram')
img2html(fileName + '.svg', 800)
netlist2html(fileName + '.cir')

i1.defPar('L_A', 0.5)
i1.defPar('C_A', '5p')
i1.defPar('C_f', '2.5p')
i1.defPar('C_c', '0.1p')
i1.defPar('ID', '0.6m')
i1.defPar('R', 200)
#i1.defPar('c_dg_XU1', 0)
i1.defPar('R_phz', 43)
i1.defPar('L_i', '4n')
i1.defPar('L_o', '12n')
elementData2html(i1.circuit)
params2html(i1.circuit)

i1.setSimType('numeric')
i1.setSource('V1')
i1.setDetector('V_out')

i1.setGainType('gain')
i1.setDataType('laplace')
gain = i1.execute()

htmlPage('Bode plots')

figdBmag = plotSweep(fileName + 'dBmag', 'dB magnitude', gain, 1e3, 10e9, 100, funcType = 'dBmag', show=True)
figPhase = plotSweep(fileName + 'phase', 'Phase', gain, 1e3, 10e9, 100, funcType = 'phase', show=True)
fig2html(figdBmag, 800)
fig2html(figPhase, 800)